/**
 **************************************************************************
 *
 *        System: sys096
 *
 *     PVCS Name: petroadmin
 *
 *   Module Name: TransactionBrowser.java
 *
 ***************************************************************************
 *
 *                       Proprietary Software Product
 *
 *
 *                     Data Transmission Network, Inc.
 *                      9110 West Dodge Road Suite 200
 *                          Omaha, Nebraska  68114
 *
 *
 *             Copyright (c) by Data Transmission Network 2004
 *                           All Rights Reserved
 *
 ***************************************************************************
 *
 * Module Descr.:
 *
 *    References:
 *
 *      Compiler: javac 1.5.0_09
 *
 *        Author: todd.patrick
 *
 *   Created on:  May 26, 2006, 9:29 AM
 *
 *   Modified By:
 *
 ***************************************************************************
 *
 *                          Function List
 *
 *    Global:
 *
 *
 *    Static:
 *
 *
 *
 **************************************************************************
*/

package com.dtn.petro2.petroadmin.transactionbrowser;

import com.dtn.petro2.petro_lib.ElementRow;
import com.dtn.petro2.petro_lib.PetroException;
import com.dtn.petro2.petro_lib.TransactRow;
import com.dtn.petro2.petroadmin.bean.transactionbrowser.TransactionBrowserSessionRemote;
import com.dtn.petro2.petroadmin.client.ClientID;
import com.dtn.petro2.petroadmin.web.BasicBean;
import oracle.adf.view.faces.component.core.data.CoreTree;
import oracle.adf.view.faces.model.ChildPropertyTreeModel;
import oracle.adf.view.faces.model.PathSet;
import oracle.adf.view.faces.model.TreeModel;
import org.apache.log4j.Logger;

import javax.ejb.EJB;
import javax.faces.application.FacesMessage;
import javax.faces.context.FacesContext;
import javax.faces.event.ActionEvent;
import javax.faces.validator.ValidatorException;
import javax.naming.NamingException;
import java.io.Serializable;
import java.sql.SQLException;
import java.util.ArrayList;
import java.util.Date;
import java.util.List;

@SuppressWarnings({"unchecked"})
public class TransactionBrowser extends BasicBean implements Serializable {
    private static final long serialVersionUID = 100320061L;
    @EJB private TransactionBrowserSessionRemote transactionBrowserSessionRemote;

    private static final Logger logger = Logger.getLogger(TransactionBrowser.class);

    private ArrayList transType = new ArrayList();
    private ArrayList tbClientID = new ArrayList();
    
    private String currentTransType;
    private Date transStartDate;
    private Date transEndDate;
    private String currentTransStartTime;
    private String currentTransEndTime;
    private String currentClientID = "0";
    private String tbFilter;
    private String tbTransID;

    private String selectedElemNodeType = "";
    private static final String FILE_ID = "file_id";

    private transient CoreTree transactTree;
    private transient TreeModel transactModel;
    private transient PathSet transactTreeState;

    private transient CoreTree elementTree;
    private transient TreeModel elementModel;
    private transient PathSet elementTreeState;

    public TransactionBrowser() {
        this.setPageTitle("Petro Admin: Transaction Browser");
    }

    public ArrayList getTransType() {
        TransactionType tType = new TransactionType();
        try {
            transType = tType.gettransactionType();
        } catch (NamingException ex) {
            ex.printStackTrace();
        } catch (SQLException ex) {
            ex.printStackTrace();
        }

        return transType;
    }

    public void setTransType(ArrayList _transType) {
        this.transType = _transType;
    }

    public String getCurrentTransType() {
        return currentTransType;
    }

    public void setCurrentTransType(String _currentTransType) {
        this.currentTransType = _currentTransType;
    }

    public Date getTransStartDate() {
        return transStartDate;
    }

    public void setTransStartDate(Date _transStartDate) {
            this.transStartDate = _transStartDate;
    }

    public ArrayList getHours() {
        TransactionTime hour = new TransactionTime();
        return hour.getIncrements();
    }

    public String getCurrentTransStartTime() {
        return currentTransStartTime;
    }

    public void setCurrentTransStartTime(String _currentTransStartTime) {
        this.currentTransStartTime = _currentTransStartTime;
    }

    public Date getTransEndDate() {
        return transEndDate;
    }

    public void setTransEndDate(Date _transEndDate) {
        this.transEndDate = _transEndDate;
    }

    public String getCurrentTransEndTime() {
        return currentTransEndTime;
    }

    public void setCurrentTransEndTime(String _currentTransEndTime) {
        this.currentTransEndTime = _currentTransEndTime;
    }

    public ArrayList getTbClientID() {
        ClientID clientId = new ClientID();
        tbClientID = clientId.getClientID();

        return tbClientID;
    }

    public void setTbClientID(ArrayList _tbClientID) {
        this.tbClientID = _tbClientID;
    }

    public String getCurrentClientID() {
        return currentClientID;
    }

    public void setCurrentClientID(String _currentClientID) {
        this.currentClientID = _currentClientID;
    }

    public String getTbFilter() {
        return tbFilter;
    }

    public void setTbFilter(String _tbFilter) {
        this.tbFilter = _tbFilter;
    }

    public String getTbTransID() {
        return tbTransID;
    }

    public void setTbTransID(String _tbTransID) {
        this.tbTransID = _tbTransID;
    }

    public String getSelectedElemNodeType() {
        return selectedElemNodeType;
    }

    public void getElementNodes() {
        if (this.getSelectedElemNodeType().equals(FILE_ID)) {
        }
    }

    public void setTransactTree(CoreTree transactTree) {
        this.transactTree = transactTree;
    }

    public CoreTree getTransactTree() {
        return this.transactTree;
    }

    public TreeModel getTransactModel() {
        return transactModel;
    }

    public void setTransactModel(TreeModel transactModel) {
        this.transactModel = transactModel;
    }

    public CoreTree getElementTree() {
        return elementTree;
    }

    public void setElementTree(CoreTree elementTree) {
        this.elementTree = elementTree;
    }

    public TreeModel getElementModel() {
        return elementModel;
    }

    public void setElementModel(TreeModel elementModel) {
        this.elementModel = elementModel;
    }

    public PathSet getElementTreeState() {
        return elementTreeState;
    }

    public void setElementTreeState(PathSet elementTreeState) {
        this.elementTreeState = elementTreeState;
    }

    public PathSet getTransactTreeState() {
        return transactTreeState;
    }

    public void setTransactTreeState(PathSet transactTreeState) {
        this.transactTreeState = transactTreeState;
    }

    public void doFreeFormSearch(ActionEvent event) throws ValidatorException {
        FacesContext context = FacesContext.getCurrentInstance();
        FacesMessage message = new FacesMessage();

        try {
            List<TransactRow> results;
            results = transactionBrowserSessionRemote.doFreeFormSearch(this.getCurrentTransType(), this.getTransStartDate(), this.getCurrentTransStartTime(), this.getTransEndDate(), this.getCurrentTransEndTime(), this.getCurrentClientID(), this.getTbFilter());
            List<TransactionNode> root = new ArrayList<TransactionNode>();

            if (results.isEmpty()) {
                throw new PetroException("No Results");
            } else {
                for (TransactRow rootRow : results) {
                    TransactionNode rootItem = new TransactionNode(rootRow.getTransactKey(), rootRow.getParentKey());
                    root.add(rootItem);
                }
            }

            /**
             * This controls whether to display the folder icon or not for a leaf node
             */
            this.setTransactModel(new ChildPropertyTreeModel(root, "children") {
                    public boolean isContainer() {
                        return ((TransactionNode)getRowData()).getChildCount() > 0;
                    }
                }
            );

        } catch (PetroException e) {
            message.setSeverity(FacesMessage.SEVERITY_ERROR);
            message.setSummary(e.getMessage());
            context.addMessage("tbForm:searchErrorFilter", message);
            logger.error("Transaction Browser Exception:", e);
        }

        FacesContext.getCurrentInstance().renderResponse();
    }

    public void doTransactionIdSearch(ActionEvent event) {
        FacesContext context = FacesContext.getCurrentInstance();
        FacesMessage message = new FacesMessage();

        try {
            /**
             * Build Transact Tree
             */
            List<TransactRow> transactionResults = transactionBrowserSessionRemote.doTransactionIdSearch(this.getTbTransID());
            List<TransactionNode> transactionRoot = new ArrayList<TransactionNode>();

            if (transactionResults.isEmpty()) {
                throw new PetroException("No transactionResults");
            } else {

                for (TransactRow transactionRootRow : transactionResults) {
                    TransactionNode transactionRootItem = new TransactionNode(transactionRootRow.getTransactKey(), transactionRootRow.getParentKey());
                    transactionRoot.add(transactionRootItem);
                }
            }

            /**
             * This controls whether to display the folder icon or not for a leaf node
             */
            this.setTransactModel(new ChildPropertyTreeModel(transactionRoot, "children") {
                    public boolean isContainer() {
                        return ((TransactionNode)getRowData()).getChildCount() > 0;
                    }
                }
            );



            /**
             * Build Element Tree
             */
            List<ElementRow> elementResults = transactionBrowserSessionRemote.doElementSearch(this.getTbTransID());
            List<ElementNode> elementRoot = new ArrayList<ElementNode>();

            if (elementResults.isEmpty()) {
                throw new PetroException("No elementResults");
            } else {

                for (ElementRow elementRow : elementResults) {
                    ElementNode rootItem = new ElementNode(elementRow.getElementKey(), elementRow.getElementKey());
                    elementRoot.add(rootItem);
                }
            }

            /**
             * This controls whether to display the folder icon or not for a leaf node
             */
            this.setTransactModel(new ChildPropertyTreeModel(elementRoot, "children") {
                    public boolean isContainer() {
                        return ((ElementNode)getRowData()).getChildCount() > 0;
                    }
                }
            );


        } catch (PetroException e) {
//            this.getTransactTreeState().getKeySet().clear();
//            this.getElementTreeState().getKeySet().clear();
//
//            AdfFacesContext.getCurrentInstance().addPartialTarget(transactTree);
//            AdfFacesContext.getCurrentInstance().addPartialTarget(elementTree);

            message.setSeverity(FacesMessage.SEVERITY_ERROR);
            message.setSummary(e.getMessage());
            context.addMessage("tbForm:searchErrorFilter", message);
            logger.error("Transaction Browser Exception:", e);
        }

        FacesContext.getCurrentInstance().renderResponse();
    }
}